package com.connor.jd.plm.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.connor.jd.plm.dialogs.CSXWHDialog;
import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCSession;

import javafx.application.Platform;
import javafx.embed.swing.JFXPanel;
import javafx.stage.Stage;

public class CSXWHHandler extends AbstractHandler {

	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException {
		AbstractAIFUIApplication app = AIFUtility.getCurrentApplication();
		TCSession session = (TCSession) app.getSession();
		new Thread(() -> {
			new JFXPanel();
			Platform.setImplicitExit(false);
			Platform.runLater(new Runnable() {
				@Override
				public void run() {
					try {
						CSXWHDialog csxwh = new CSXWHDialog();
						csxwh.start(new Stage());
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			});
		}).start();
		return null;
	}

}
