package com.connor.jd.plm.table;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.DefaultCellEditor;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JTable;

import com.teamcenter.rac.util.DateButton;

public class ButtonEditor extends DefaultCellEditor {
	protected DateButton button;
	private String label;
	private boolean isPushed;

	public ButtonEditor(JCheckBox checkBox) {
		super(checkBox);
		button = new DateButton();
		
	}

	public Component getTableCellEditorComponent(JTable table, Object value, 
			boolean isSelected, int row, int column) {
		if (isSelected) {
			button.setForeground(table.getSelectionForeground());
			button.setBackground(table.getSelectionBackground());
		} else {
			button.setForeground(table.getForeground());
			button.setBackground(table.getBackground());
		}
		
		return button;
	}

	public Object getCellEditorValue() {
		//yyyyMMdd
		SimpleDateFormat format=new SimpleDateFormat("yyyyMMdd");
		SimpleDateFormat format2=new SimpleDateFormat("MM");
		SimpleDateFormat format3=new SimpleDateFormat("dd");
		Date data = new Date();
		System.out.println("aaa===>"+format2.format(data));
		System.out.println("bbb===>"+format3.format(data));
		System.out.println("ccc===>"+format.format(data));		
		
		return format.format(button.getDate());
	}

}